KConfig class Reference (kdecore Library)

| # kdecore Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KConfig Class Reference

Access KDE Configuration entries. KDE Configuration Management class. More...

`#include <kconfig.h>`

Inheritance diagram for KConfig:

[legend]
Collaboration diagram for KConfig:

[legend]
List of all members.

## Public Member Functions
| KConfig (const QString &fileName=QString::null, bool bReadOnly=false, bool bUseKDEGlobals=true, const char *resType="config")
| Constructs a KConfig object.
virtual | ~KConfig ()
| Destructs the KConfig object.
virtual void | rollback (bool bDeep=true)
| Clears all entries out of the `dirtyEntryMap`, so the values will not be written to disk on a later call to sync().
virtual QStringList | groupList () const
| Returns a list of groups that are known.
virtual QMap< QString, QString > | entryMap (const QString &pGroup) const
| Returns a map (tree) of entries for all entries in a particular group.
virtual void | reparseConfiguration ()
| Clears all internal data structures and then reread configuration information from disk.
void | setFileWriteMode (int mode)
| Set the file mode for newly created files.
void | setForceGlobal (bool force)
| Forces all following write-operations being performed on kdeglobals, independent of the bGlobal flag in writeEntry().
bool | forceGlobal () const
| Returns true if all entries are being written into kdeglobals.
void | checkUpdate (const QString &id, const QString &updateFile)
| Checks whether the config file contains the update `id` as contained in `updateFile`.
## Protected Member Functions
virtual bool | internalHasGroup (const QCString &group) const
| Returns true if the specified group is known.
virtual KEntryMap | internalEntryMap (const QString &pGroup) const
| Returns a map (tree) of the entries in the specified group.
virtual KEntryMap | internalEntryMap () const
| Returns a copy of the internal map used to hold all entries.
virtual void | putData (const KEntryKey &_key, const KEntry &_data, bool _checkGroup=true)
| Inserts a (key, value) pair into the internal storage mechanism of the configuration object.
virtual KEntry | lookupData (const KEntryKey &_key) const
| Looks up an entry in the config object's internal structure.
virtual void | virtual_hook (int id, void *data)
## Protected Attributes
KEntryMap | aEntryMap
| Contains all key,value entries, as well as some "special" keys which indicate the start of a group of entries.

## Detailed Description

Access KDE Configuration entries. KDE Configuration Management class.

This class implements KDE's default configuration system.

Author:
  Kalle Dalheimer <kalle@kde.org>, Preston Brown <pbrown@kde.org>

Version:
  Id
    kconfig.h,v 1.51 2002/09/28 12:28:47 tjansen Exp

See also:
  KGlobal::config(), KConfigBase, KSimpleConfig

Definition at line 43 of file kconfig.h.

## Constructor & Destructor Documentation

KConfig::KConfig | ( | const QString & | fileName = QString::null,
|  | bool | bReadOnly = false,
|  | bool | bUseKDEGlobals = true,
|  | const char * | resType = "config"
| ) |

  | Constructs a KConfig object. Parameters:
  fileName | A file to parse in addition to the system-wide file(s). If it is not provided, only global KDE configuration data will be read (depending on the value of `bUseKDEGlobals`).
  bReadOnly | Set the config object's read-only status. Note that the object will automatically become read-only if either the user does not have write permission to `fileName` or if no file was specified.
  bUseKDEGlobals | Toggle reading the global KDE configuration file.
  resType | the place to look in (config, data, etc) See KStandardDirs.
Definition at line 43 of file kconfig.cpp. References KStandardDirs::addCustomized(), KConfigBase::backEnd, KGlobal::dirs(), reparseConfiguration(), and KConfigBase::setReadOnly().

KConfig::~KConfig | ( |  | ) | `[virtual]`

| Destructs the KConfig object. Writes back any dirty configuration entries, and destroys dynamically created objects. Definition at line 76 of file kconfig.cpp. References KConfigBase::backEnd, and KConfigBase::sync().

## Member Function Documentation

void KConfig::rollback | ( | bool | bDeep = true | ) | `[virtual]`

  | Clears all entries out of the `dirtyEntryMap`, so the values will not be written to disk on a later call to sync(). Parameters:
  bDeep | If true, the dirty map is actually emptied. otherwise, the config object's global dirty flag is set to false, but the dirty entries remain in the dirty entry map.
See also: KConfigBase::rollback Reimplemented from KConfigBase. Definition at line 83 of file kconfig.cpp. References aEntryMap, QMap::begin(), QMap::end(), and KConfigBase::rollback(). Referenced by KSimpleConfig::sync().

QStringList KConfig::groupList | ( |  | ) | const`[virtual]`

| Returns a list of groups that are known. Returns: a list of of groups Implements KConfigBase. Definition at line 96 of file kconfig.cpp. References aEntryMap, QMap::begin(), QMap::end(), QString::fromUtf8(), KConfigBase::group(), and QMap::isEmpty().

QMap< QString, QString > KConfig::entryMap | ( | const QString & | pGroup | ) | const`[virtual]`

  | Returns a map (tree) of entries for all entries in a particular group. Only the actual entry string is returned, none of the other internal data should be included. Parameters:
  pGroup | A group to get keys from.
Returns: A map of entries in the group specified, indexed by key. The returned map may be empty if the group is not found. Implements KConfigBase. Definition at line 130 of file kconfig.cpp. References aEntryMap, QMap::end(), QMap::find(), QString::fromUtf8(), QMap::insert(), and QString::utf8(). Referenced by KStandardDirs::addCustomized().

void KConfig::reparseConfiguration | ( |  | ) | `[virtual]`

| Clears all internal data structures and then reread configuration information from disk. Implements KConfigBase. Definition at line 150 of file kconfig.cpp. References aEntryMap, QMap::clear(), QMap::insert(), and KConfigBase::parseConfigFiles(). Referenced by checkUpdate(), KInstance::config(), KInstance::dirs(), KConfig(), KDesktopFile::KDesktopFile(), and KSimpleConfig::KSimpleConfig().

void KConfig::setFileWriteMode | ( | int | mode | ) |

  | Set the file mode for newly created files. Parameters:
  mode | the mode for new files as described in chmod(2)
See also: man:chmod(2) for a description of `mode` Definition at line 259 of file kconfig.cpp. References KConfigBase::backEnd, and KConfigBackEnd::setFileWriteMode().

void KConfig::setForceGlobal | ( | bool | force | ) | `[inline]`

  | Forces all following write-operations being performed on kdeglobals, independent of the bGlobal flag in writeEntry(). Parameters:
  force | true to force writing in kdeglobals
See also: forceGlobal Definition at line 126 of file kconfig.h.

bool KConfig::forceGlobal | ( |  | ) | const`[inline]`

| Returns true if all entries are being written into kdeglobals. Returns: true if all entries are being written into kdeglobals See also: setForceGlobal Definition at line 133 of file kconfig.h.

void KConfig::checkUpdate | ( | const QString & | id,
|  | const QString & | updateFile
| ) |

  | Checks whether the config file contains the update `id` as contained in `updateFile`. If not, it runs kconf_update to update the config file. If you install config update files with critical fixes you may wish to use this method to verify that a critical update has indeed been performed to catch the case where a user restores an old config file from backup that has not been updated yet. Parameters:
  id | the update to check
  updateFile | the file containing the update
Since: 3.1 Definition at line 264 of file kconfig.cpp. References KConfigBase::group(), KApplication::kdeinitExecWait(), KConfigBase::readListEntry(), reparseConfiguration(), and KConfigBase::setGroup().

bool KConfig::internalHasGroup | ( | const QCString & | group | ) | const`[protected, virtual]`

  | Returns true if the specified group is known. Parameters:
  group | The group to search for.
Returns: true if the group exists. Implements KConfigBase. Definition at line 238 of file kconfig.cpp. References aEntryMap, QMap::end(), QMap::find(), and QMap::isEmpty().

KEntryMap KConfig::internalEntryMap | ( | const QString & | pGroup | ) | const`[protected, virtual]`

  | Returns a map (tree) of the entries in the specified group. Do not use this function, the implementation / return type are subject to change. Parameters:
  pGroup | the group to provide a KEntryMap for.
Returns: The map of the entries in the group. Implements KConfigBase. Definition at line 163 of file kconfig.cpp. References aEntryMap, QMap::end(), QMap::find(), QMap::insert(), and QString::utf8().

virtual KEntryMap KConfig::internalEntryMap | ( |  | ) | const`[inline, protected, virtual]`

  | Returns a copy of the internal map used to hold all entries. Do not use this function, the implementation / return type are subject to change. Parameters:
  pGroup | the group to provide a KEntryMap for.
Returns: The map of the entries in the group. Implements KConfigBase. Definition at line 183 of file kconfig.h. References aEntryMap.

void KConfig::putData | ( | const KEntryKey & | _key,
|  | const KEntry & | _data,
|  | bool | _checkGroup = true
| ) | `[protected, virtual]`

  | Inserts a (key, value) pair into the internal storage mechanism of the configuration object. Parameters:
  _key | The key to insert. It contains information both on the group of the key and the key itself. If the key already exists, the old value will be replaced.
  _data | the KEntry that is to be stored.
  _checkGroup | When false, assume that the group already exists.
Implements KConfigBase. Definition at line 187 of file kconfig.cpp. References aEntryMap, KEntryKey::bDefault, KEntry::bGlobal, KEntry::bImmutable, KStdAccel::key(), and KEntryKey::mGroup.

KEntry KConfig::lookupData | ( | const KEntryKey & | _key | ) | const`[protected, virtual]`

  | Looks up an entry in the config object's internal structure. Parameters:
  _key | The key to look up It contains information both on the group of the key and the entry's key itself.
Returns: the KEntry value (data) found for the key. KEntry.aValue will be the null string if nothing was located. Implements KConfigBase. Definition at line 222 of file kconfig.cpp. References aEntryMap, KEntry::bDeleted, QMap::end(), and QMap::find().

## Member Data Documentation

KEntryMap KConfig::aEntryMap`[protected]`

| Contains all key,value entries, as well as some "special" keys which indicate the start of a group of entries. These special keys will have the .key portion of their KEntryKey set to QString::null. Definition at line 214 of file kconfig.h. Referenced by entryMap(), groupList(), internalEntryMap(), internalHasGroup(), lookupData(), putData(), reparseConfiguration(), and rollback().

The documentation for this class was generated from the following files:

- kconfig.h
- kconfig.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 12:47:40 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001